package org.me.reproducer;

import java.util.Map;
import javax.activation.DataHandler;
import javax.annotation.Resource;
import javax.jws.WebService;
import javax.jws.WebMethod;
import javax.ejb.Stateless;
import javax.mail.internet.MimeMultipart;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.handler.MessageContext;

/**
 *
 * @author Jan
 */
@WebService(serviceName = "ReproducerWS")
@Stateless()
public class MyWebService {
    
    @Resource
    private WebServiceContext context; 
    
    @WebMethod(operationName="msg1")
    public String getContextMessageDump() {
        try {
            Map attachments = (Map)context.getMessageContext().get(MessageContext.INBOUND_MESSAGE_ATTACHMENTS);
            DataHandler dh = (DataHandler)attachments
                    .values()
                    .iterator()
                    .next();
            MimeMultipart mmp =  new MimeMultipart(dh.getDataSource());
            return mmp.toString();
        } catch (Exception e) {
            e.printStackTrace();
            return "exception occurred " + e.toString();
        }
    }
    
    @WebMethod(operationName="msg2")
    public String getContextMessageDumpTwice() {
        try {
            Map attachments = (Map)context.getMessageContext().get(MessageContext.INBOUND_MESSAGE_ATTACHMENTS);
            DataHandler dh = (DataHandler)attachments
                    .values()
                    .iterator()
                    .next();
            MimeMultipart mmp =  new MimeMultipart(dh.getDataSource());
            MimeMultipart mmp2 =  new MimeMultipart(dh.getDataSource());
            return mmp.toString() + mmp2.toString();
        } catch (Exception e) {
            e.printStackTrace();
            return "exception occurred " + e.toString();
        }
    }
}
